#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_StarLotteryEventCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_StarLotteryEventCFG> M_StarLotteryEventCFG::msSingleton(nullptr);

int M_StarLotteryEventCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_StarLotteryEventCFGData* M_StarLotteryEventCFG::GetData(int Type)
{
	auto it = mMapData.find(Type);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_StarLotteryEventCFGData>& M_StarLotteryEventCFG::GetMapData()
{
	return mMapData;
}

void M_StarLotteryEventCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_StarLotteryEventCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_StarLotteryEventCFGData data;
		data.mType = element->IntAttribute("Type");
		data.mDailyADD = element->IntAttribute("DailyADD");
		data.mTotalADD = element->IntAttribute("TotalADD");
		if (mMapData.find(data.mType) != mMapData.end())std::cout <<"data refind:" << data.mType << std::endl;
		assert(mMapData.find(data.mType) == mMapData.end());
		mMapData.insert(std::make_pair(data.mType, data));
		element = element->NextSiblingElement();
	}
}

void M_StarLotteryEventCFG::Load()
{
	Load("../Config/M_StarLotteryEventCFG.xml");
}

M_StarLotteryEventCFG* M_StarLotteryEventCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_StarLotteryEventCFG());
	}
	return msSingleton.get();
}
